/* Output from p2c, the Pascal-to-C translator */
/* p2c: bm2mf.p, line 1: Note: Range checking is OFF [216] */
/* p2c: bm2mf.p, line 1: Note: Stack checking is OFF [217] */
/* From input file "bm2mf.p" */
 
 
/*$A-,B-,D-,E-,F-,I+,L-,N-,O-,R-,S-,V-*/
/*Compile with Turbo-Pascal 5.0*/
 
#include "p2c.h" 
/* #include <p2c/p2c.h> */
 
 
/*
  This program generates METAFONT code from a JIS Bitmaps file
 
  Author: Francois Jalbert
              '
  Date: November 1990
 
  Modifier: Masatoshi Watanabe
 
  Date_Modified: February 1991
 
*/
/* Translated to C by p2c and modified by Tsuchiya. */
/*Number of Bitmaps in JIS*/
#define BitmapMax       7896
 
 
/*The Bitmap array is defined larger to simplify the forthcoming code*/
typedef boolean BitmapType[66][66];
 
 
/*Bitmap and METAFONT file names*/
Static FILE *InFile;
Static FILE *OutFile;
Static Char FileName[256];
Static double Bold;
 
/*Bitmap pointers*/
Static short CurrentBitmap, WantedBitmap;
Static short BitmapPtr;
 
/*Size of each square Bitmap*/
Static uchar SizeMax, SizeMax1, SizeExt;
Static short ErrFlag;
 
/*Current Bitmap and its dimensions*/
Static BitmapType Bitmap;
Static char XMin, XMax, YMin, YMax;
 
/*Used to skip Bitmaps since only sequential file access is available*/
Static uchar Data;
Static short X;
 
/*Current METAFONT character number*/
Static short Number;
Static Char InFile_NAME[_FNSIZE];
Static Char OutFile_NAME[_FNSIZE];
 
 
Static Void ScanBitmap(InFile, Bitmap)
FILE **InFile;
boolean (*Bitmap)[66];
{
  /* (0,0) is lower left corner of Bitmap */
  char X, Y;
  char FORLIM, FORLIM1;
 
  FORLIM = SizeMax1;
  /*First clear the area outside the Bitmap*/
  for (X = 0; X <= FORLIM; X++) {
    Bitmap[X][0] = false;
    Bitmap[X][SizeMax1] = false;
  }
  FORLIM = SizeMax1;
  for (Y = 0; Y <= FORLIM; Y++) {
    Bitmap[0][Y] = false;
    Bitmap[SizeMax1][Y] = false;
  }
  /*Read the Bitmap*/
  for (Y = SizeMax; Y >= 1; Y--) {
    FORLIM1 = (SizeMax - 1) / 8;
    for (X = 0; X <= FORLIM1; X++) {
      fread(&Data, sizeof(uchar), 1, *InFile);
      Bitmap[X * 8 + 1][Y] = ((Data & 0x80) != 0);
      Bitmap[X * 8 + 2][Y] = ((Data & 0x40) != 0);
      Bitmap[X * 8 + 3][Y] = ((Data & 0x20) != 0);
      Bitmap[X * 8 + 4][Y] = ((Data & 0x10) != 0);
      Bitmap[X * 8 + 5][Y] = ((Data & 0x8) != 0);
      Bitmap[X * 8 + 6][Y] = ((Data & 0x4) != 0);
      Bitmap[X * 8 + 7][Y] = ((Data & 0x2) != 0);
      Bitmap[X * 8 + 8][Y] = ((Data & 0x1) != 0);
    }
  }
}
 
 
Static Void ScanSides(Bitmap, XMin, XMax, YMin, YMax)
boolean (*Bitmap)[66];
char *XMin, *XMax, *YMin, *YMax;
{
  char X, Y, FORLIM, FORLIM1;
 
  *XMin = SizeMax1;
  for (X = SizeMax; X >= 1; X--) {
    FORLIM1 = SizeMax;
    for (Y = 1; Y <= FORLIM1; Y++) {
      if (Bitmap[X][Y])
	*XMin = X;
    }
  }
  *XMax = 0;
  FORLIM1 = SizeMax;
  for (X = 1; X <= FORLIM1; X++) {
    FORLIM = SizeMax;
    for (Y = 1; Y <= FORLIM; Y++) {
      if (Bitmap[X][Y])
	*XMax = X;
    }
  }
  *YMin = SizeMax1;
  for (Y = SizeMax; Y >= 1; Y--) {
    FORLIM = SizeMax;
    for (X = 1; X <= FORLIM; X++) {
      if (Bitmap[X][Y])
	*YMin = Y;
    }
  }
  *YMax = 0;
  FORLIM1 = SizeMax;
  for (Y = 1; Y <= FORLIM1; Y++) {
    FORLIM = SizeMax;
    for (X = 1; X <= FORLIM; X++) {
      if (Bitmap[X][Y])
	*YMax = Y;
    }
  }
}
 
 
Static Void BeginOut(OutFile, FileName)
FILE **OutFile;
Char *FileName;
{
  fprintf(*OutFile, "%%%s\n\n", FileName);
  fprintf(*OutFile, "if unknown cmbase: input cmbase fi\n");
  fprintf(*OutFile, "tracingstats:=1; %%stats in .log file\n");
  fprintf(*OutFile, "font_size 10pt#;\n");
  fprintf(*OutFile, "u#:=9.1542/%dpt#;\n", (SizeMax + SizeExt));
  fprintf(*OutFile, "body_height#:=32/300in#;\n");
  fprintf(*OutFile, "desc_depth#:=6/300in#;\n\n");
  fprintf(*OutFile, "letter_fit#:=0pt#;\n");
  fprintf(*OutFile, "asc_height#:=0pt#;\n");
  fprintf(*OutFile, "cap_height#:=0pt#;\n");
  fprintf(*OutFile, "fig_height#:=0pt#;\n");
  fprintf(*OutFile, "x_height#:=0pt#;\n");
  fprintf(*OutFile, "math_axis#:=0pt#;\n");
  fprintf(*OutFile, "bar_height#:=0pt#;\n");
  fprintf(*OutFile, "comma_depth#:=0pt#;\n");
  fprintf(*OutFile, "crisp#:=0pt#;\n");
  fprintf(*OutFile, "tiny#:=0pt#;\n");
  fprintf(*OutFile, "fine#:=0pt#;\n");
  fprintf(*OutFile, "thin_join#:=0pt#;\n");
  fprintf(*OutFile, "hair#:=1pt#;\n");
  fprintf(*OutFile, "stem#:=1pt#;\n");
  fprintf(*OutFile, "curve#:=1pt#;\n");
  fprintf(*OutFile, "flare#:=1pt#;\n");
  fprintf(*OutFile, "dot_size#:=0pt#;\n");
  fprintf(*OutFile, "cap_hair#:=1pt#;\n");
  fprintf(*OutFile, "cap_stem#:=1pt#;\n");
  fprintf(*OutFile, "cap_curve#:=1pt#;\n");
  fprintf(*OutFile, "rule_thickness#:=0pt#;\n");
  fprintf(*OutFile, "vair#:=0pt#;\n");
  fprintf(*OutFile, "notch_cut#:=0pt#;\n");
  fprintf(*OutFile, "bar#:=1pt#;\n");
  fprintf(*OutFile, "slab#:=1pt#;\n");
  fprintf(*OutFile, "cap_bar#:=1pt#;\n");
  fprintf(*OutFile, "cap_band#:=1pt#;\n");
  fprintf(*OutFile, "cap_notch_cut#:=0pt#;\n");
  fprintf(*OutFile, "serif_drop#:=0pt#;\n");
  fprintf(*OutFile, "stem_corr#:=0pt#;\n");
  fprintf(*OutFile, "vair_corr#:=0pt#;\n");
  fprintf(*OutFile, "o#:=0pt#;\n");
  fprintf(*OutFile, "apex_o#:=0pt#;\n");
  fprintf(*OutFile, "hefty:=true;\n");
  fprintf(*OutFile, "serifs:=true;\n");
  fprintf(*OutFile, "monospace:=false;\n");
  fprintf(*OutFile, "math_fitting:=false;\n\n");
  fprintf(*OutFile, "mode_setup;\n");
  fprintf(*OutFile, "font_setup;\n\n");
  fprintf(*OutFile, "pair z;\n\n");
  fprintf(*OutFile, "def s(expr col,row)= %%square\n");
  fprintf(*OutFile, " z:=((col*u)-%4.2fu,(row*u)-%4.2fu);\n",
	  Bold - 0.5, Bold - 0.5);
  fprintf(*OutFile, " fill unitsquare scaled %4.2fu shifted z;\n", Bold * 2);
  fprintf(*OutFile, "enddef;\n");
  fprintf(*OutFile, "def sul(expr col,row)= %%upper left square\n");
  fprintf(*OutFile, " z:=((col*u)-%4.2fu,(row*u)+.5u);\n", Bold - 0.5);
  fprintf(*OutFile, " fill unitsquare scaled %4.2fu shifted z;\n", Bold);
  fprintf(*OutFile, "enddef;\n");
  fprintf(*OutFile, "def sur(expr col,row)= %%upper right square\n");
  fprintf(*OutFile, " z:=((col*u)+.5u,(row*u)+.5u);\n");
  fprintf(*OutFile, " fill unitsquare scaled %4.2fu shifted z;\n", Bold);
  fprintf(*OutFile, "enddef;\n");
  fprintf(*OutFile, "def sbr(expr col,row)= %%bottom right square\n");
  fprintf(*OutFile, " z:=((col*u)+.5u,(row*u)-%4.2fu);\n", Bold - 0.5);
  fprintf(*OutFile, " fill unitsquare scaled %4.2fu shifted z;\n", Bold);
  fprintf(*OutFile, "enddef;\n");
  fprintf(*OutFile, "def sbl(expr col,row)= %%bottom left square\n");
  fprintf(*OutFile, " z:=((col*u)-%4.2fu,(row*u)-%4.2fu);\n",
	  Bold - 0.5, Bold - 0.5);
  fprintf(*OutFile, " fill unitsquare scaled %4.2fu shifted z;\n", Bold);
  fprintf(*OutFile, "enddef;\n\n");
  fprintf(*OutFile, "def c(expr col,row)= %%circle\n");
  fprintf(*OutFile, " z:=((col*u)+.5u,(row*u)+.5u);\n");
  fprintf(*OutFile, " fill fullcircle scaled %4.2fu shifted z;\n", Bold * 2);
  fprintf(*OutFile, "enddef;\n");
  fprintf(*OutFile, "def tul(expr col,row)= %%upper left triangle\n");
  fprintf(*OutFile, " z:=((col*u)+.5u,(row*u)+.5u);\n");
  fprintf(*OutFile, " fill z--z+(0,%4.2fu)--z+(%5.2fu,%4.2fu)--",
	  Bold, 0.5 - Bold, Bold);
  fprintf(*OutFile, "z-(%4.2fu,%5.2fu)--z-(%4.2fu,0)--cycle;\n",
	  Bold, 0.5 - Bold, Bold);
  fprintf(*OutFile, "enddef;\n");
  fprintf(*OutFile, "def tur(expr col,row)= %%upper right triangle\n");
  fprintf(*OutFile, " z:=((col*u)+.5u,(row*u)+.5u);\n");
  fprintf(*OutFile, " fill z--z+(0,%4.2fu)--z+(%4.2fu,%4.2fu)--",
	  Bold, Bold - 0.5, Bold);
  fprintf(*OutFile, "z+(%4.2fu,%4.2fu)--z+(%4.2fu,0)--cycle;\n",
	  Bold, Bold - 0.5, Bold);
  fprintf(*OutFile, "enddef;\n");
  fprintf(*OutFile, "def tbr(expr col,row)= %%bottom right triangle\n");
  fprintf(*OutFile, " z:=((col*u)+.5u,(row*u)+.5u);\n");
  fprintf(*OutFile, " fill z--z-(0,%4.2fu)--z-(%5.2fu,%4.2fu)--",
	  Bold, 0.5 - Bold, Bold);
  fprintf(*OutFile, "z+(%4.2fu,%5.2fu)--z+(%4.2fu,0)--cycle;\n",
	  Bold, 0.5 - Bold, Bold);
  fprintf(*OutFile, "enddef;\n");
  fprintf(*OutFile, "def tbl(expr col,row)= %%bottom left triangle\n");
  fprintf(*OutFile, " z:=((col*u)+.5u,(row*u)+.5u);\n");
  fprintf(*OutFile, " fill z--z-(0,%4.2fu)--z-(%4.2fu,%4.2fu)--",
	  Bold, Bold - 0.5, Bold);
  fprintf(*OutFile, "z-(%4.2fu,%4.2fu)--z-(%4.2fu,0)--cycle;\n",
	  Bold, Bold - 0.5, Bold);
  fprintf(*OutFile, "enddef;\n");
  fprintf(*OutFile, "\n\n");
  fprintf(*OutFile, "def rul(expr col,row)= %%upper left reverse triangle\n");
  fprintf(*OutFile, " z:=((col*u)+%4.2fu,(row*u)+%4.2fu);\n",
	  Bold - 0.5, 1.5 - Bold);
  fprintf(*OutFile, " fill z--z-(0,.5u)--z+(.5u,0)--cycle;\n");
  fprintf(*OutFile, "enddef;\n");
  fprintf(*OutFile, "def rur(expr col,row)= %%upper right reverse triangle\n");
  fprintf(*OutFile, " z:=((col*u)+%4.2fu,(row*u)+%4.2fu);\n",
	  1.5 - Bold, 1.5 - Bold);
  fprintf(*OutFile, " fill z--z-(0,.5u)--z-(.5u,0)--cycle;\n");
  fprintf(*OutFile, "enddef;\n");
  fprintf(*OutFile, "def rbr(expr col,row)= %%bottom right reverse triangle\n");
  fprintf(*OutFile, " z:=((col*u)+%4.2fu,(row*u)+%4.2fu);\n",
	  1.5 - Bold, Bold - 0.5);
  fprintf(*OutFile, " fill z--z+(0,.5u)--z-(.5u,0)--cycle;\n");
  fprintf(*OutFile, "enddef;\n");
  fprintf(*OutFile, "def rbl(expr col,row)= %%bottom left reverse triangle\n");
  fprintf(*OutFile, " z:=((col*u)+%4.2fu,(row*u)+%4.2fu);\n",
	  Bold - 0.5, Bold - 0.5);
  fprintf(*OutFile, " fill z--z+(0,.5u)--z+(.5u,0)--cycle;\n");
  fprintf(*OutFile, "enddef;\n");
  fprintf(*OutFile, "\n\n");
  fprintf(*OutFile, "def tuul(expr col,row)= %%upper left long triangle\n");
  fprintf(*OutFile, " z:=((col*u)+u,(row*u)+.5u);\n");
  fprintf(*OutFile, " fill z--z+(0,%4.2fu)--z+(%5.2fu,%4.2fu)--",
	  Bold, 0.5 - Bold, Bold);
  fprintf(*OutFile, "z-(%4.2fu,%5.2fu)--z-(%4.2fu,0)--cycle;\n",
	  Bold + 0.5, 0.5 - Bold, Bold + 0.5);
  fprintf(*OutFile, "enddef;\n");
  fprintf(*OutFile, "def tull(expr col,row)= %%upper left long triangle\n");
  fprintf(*OutFile, " z:=((col*u)+.5u,(row*u));\n");
  fprintf(*OutFile, " fill z--z+(0,%4.2fu)--z+(%5.2fu,%4.2fu)--",
	  Bold + 0.5, 0.5 - Bold, Bold + 0.5);
  fprintf(*OutFile, "z-(%4.2fu,%5.2fu)--z-(%4.2fu,0)--cycle;\n",
	  Bold, 0.5-Bold, Bold);
  fprintf(*OutFile, "enddef;\n");
  fprintf(*OutFile, "def tuur(expr col,row)= %%upper right long triangle\n");
  fprintf(*OutFile, " z:=((col*u),(row*u)+.5u);\n");
  fprintf(*OutFile, " fill z--z+(0,%4.2fu)--z+(%4.2fu,%4.2fu)--",
	  Bold, Bold - 0.5, Bold);
  fprintf(*OutFile, "z+(%4.2fu,%5.2fu)--z+(%4.2fu,0)--cycle;\n",
	  Bold + 0.5, Bold - 0.5, Bold + 0.5);
  fprintf(*OutFile, "enddef;\n");
  fprintf(*OutFile, "def turr(expr col,row)= %%upper right long triangle\n");
  fprintf(*OutFile, " z:=((col*u)+.5u,(row*u));\n");
  fprintf(*OutFile, " fill z--z+(0,%4.2fu)--z+(%4.2fu,%4.2fu)--",
	  Bold + 0.5, Bold - 0.5, Bold + 0.5);
  fprintf(*OutFile, "z+(%4.2fu,%4.2fu)--z+(%4.2fu,0)--cycle;\n",
	  Bold, Bold - 0.5, Bold);
  fprintf(*OutFile, "enddef;\n");
  fprintf(*OutFile, "def tbbr(expr col,row)= %%bottom right long triangle\n");
  fprintf(*OutFile, " z:=((col*u),(row*u)+.5u);\n");
  fprintf(*OutFile, " fill z--z-(0,%4.2fu)--z-(%5.2fu,%4.2fu)--",
	  Bold, 0.5 - Bold, Bold);
  fprintf(*OutFile, "z+(%4.2fu,%4.2fu)--z+(%4.2fu,0)--cycle;\n",
	  Bold + 0.5, 0.5 - Bold, Bold + 0.5);
  fprintf(*OutFile, "enddef;\n");
  fprintf(*OutFile, "def tbrr(expr col,row)= %%bottom right long triangle\n");
  fprintf(*OutFile, " z:=((col*u)+.5u,(row*u)+u);\n");
  fprintf(*OutFile, " fill z--z-(0,%4.2fu)--z-(%5.2fu,%4.2fu)--",
	  Bold + 0.5, 0.5 - Bold, Bold + 0.5);
  fprintf(*OutFile, "z+(%4.2fu,%5.2fu)--z+(%4.2fu,0)--cycle;\n",
	  Bold, 0.5 - Bold, Bold);
  fprintf(*OutFile, "enddef;\n");
  fprintf(*OutFile, "def tbbl(expr col,row)= %%bottom left long triangle\n");
  fprintf(*OutFile, " z:=((col*u)+u,(row*u)+.5u);\n");
  fprintf(*OutFile, " fill z--z-(0,%4.2fu)--z-(%4.2fu,%4.2fu)--",
	  Bold, Bold - 0.5, Bold);
  fprintf(*OutFile, "z-(%5.2fu,%4.2fu)--z-(%4.2fu,0)--cycle;\n",
	  Bold + 0.5, Bold - 0.5, Bold + 0.5);
  fprintf(*OutFile, "enddef;\n");
  fprintf(*OutFile, "def tbll(expr col,row)= %%bottom left long triangle\n");
  fprintf(*OutFile, " z:=((col*u)+.5u,(row*u)+u);\n");
  fprintf(*OutFile, " fill z--z-(0,%4.2fu)--z-(%4.2fu,%4.2fu)--",
	  Bold + 0.5, Bold - 0.5, Bold + 0.5);
  fprintf(*OutFile, "z-(%4.2fu,%4.2fu)--z-(%4.2fu,0)--cycle;\n",
	  Bold, Bold - 0.5, Bold);
  fprintf(*OutFile, "enddef;\n");
  fprintf(*OutFile, "\n\n");
  fprintf(*OutFile, "def ruul(expr col,row)= %%upper left reverse long triangle\n");
  fprintf(*OutFile, " z:=((col*u)+%4.2fu,(row*u)+%4.2fu);\n",
	  Bold - 0.5, 1.5 - Bold);
  fprintf(*OutFile, " fill z--z-(0,u)--z+(.5u,0)--cycle;\n");
  fprintf(*OutFile, "enddef;\n");
  fprintf(*OutFile, "def rull(expr col,row)= %%upper left reverse long triangle\n");
  fprintf(*OutFile, " z:=((col*u)+%4.2fu,(row*u)+%4.2fu);\n",
	  Bold - 0.5, 1.5 - Bold);
  fprintf(*OutFile, " fill z--z-(0,.5u)--z+(u,0)--cycle;\n");
  fprintf(*OutFile, "enddef;\n");
  fprintf(*OutFile, "def ruur(expr col,row)= %%upper right reverse long triangle\n");
  fprintf(*OutFile, " z:=((col*u)+%4.2fu,(row*u)+%4.2fu);\n",
	  1.5 - Bold, 1.5 - Bold);
  fprintf(*OutFile, " fill z--z-(0,u)--z-(.5u,0)--cycle;\n");
  fprintf(*OutFile, "enddef;\n");
  fprintf(*OutFile, "def rurr(expr col,row)= %%upper right reverse long triangle\n");
  fprintf(*OutFile, " z:=((col*u)+%4.2fu,(row*u)+%4.2fu);\n",
	  1.5 - Bold, 1.5 - Bold);
  fprintf(*OutFile, " fill z--z-(0,.5u)--z-(u,0)--cycle;\n");
  fprintf(*OutFile, "enddef;\n");
  fprintf(*OutFile, "def rbbr(expr col,row)= %%bottom right reverse long triangle\n");
  fprintf(*OutFile, " z:=((col*u)+%4.2fu,(row*u)+%4.2fu);\n",
	  1.5 - Bold, Bold - 0.5);
  fprintf(*OutFile, " fill z--z+(0,u)--z-(.5u,0)--cycle;\n");
  fprintf(*OutFile, "enddef;\n");
  fprintf(*OutFile, "def rbrr(expr col,row)= %%bottom right reverse long triangle\n");
  fprintf(*OutFile, " z:=((col*u)+%4.2fu,(row*u)+%4.2fu);\n",
	  1.5 - Bold, Bold - 0.5);
  fprintf(*OutFile, " fill z--z+(0,.5u)--z-(u,0)--cycle;\n");
  fprintf(*OutFile, "enddef;\n");
  fprintf(*OutFile, "def rbbl(expr col,row)= %%bottom left reverse long triangle\n");
  fprintf(*OutFile, " z:=((col*u)+%4.2fu,(row*u)+%4.2fu);\n",
	  Bold - 0.5, Bold - 0.5);
  fprintf(*OutFile, " fill z--z+(0,u)--z+(.5u,0)--cycle;\n");
  fprintf(*OutFile, "enddef;\n");
  fprintf(*OutFile, "def rbll(expr col,row)= %%bottom left reverse long triangle\n");
  fprintf(*OutFile, " z:=((col*u)+%4.2fu,(row*u)+%4.2fu);\n",
	  Bold - 0.5, Bold - 0.5);
  fprintf(*OutFile, " fill z--z+(0,.5u)--z+(u,0)--cycle;\n");
  fprintf(*OutFile, "enddef;\n\n");
}
 
 
Static Void MiddleOut(OutFile, Bitmap, XMin, XMax, YMin, YMax, Number)
FILE **OutFile;
boolean (*Bitmap)[66];
char XMin, XMax, YMin, YMax;
short Number;
{
  char X, Y, Depth, ExtSp;
  boolean Active, SquareUR, SquareUL, SquareBR, SquareBL, CircleUR, CircleUL,
	  CircleBR, CircleBL, LTryUUR, LTryURR, LTryUUL, LTryULL, LTryBBR,
	  LTryBRR, LTryBBL, LTryBLL;
  char FORLIM1;
 
  fprintf(*OutFile, "beginchar(%d,38/300in#,", Number);
  fprintf(*OutFile, "body_height#,desc_depth#);\n");
  fprintf(*OutFile, "normal_adjust_fit(0,0);\n");
  Depth = (SizeMax + SizeExt) / 6;
  ExtSp = SizeExt/2 - 1;
  for (X = XMin; X <= XMax; X++) {
    FORLIM1 = SizeMax;
    for (Y = 1; Y <= FORLIM1; Y++) {
      Active = false;
      if (Bitmap[X][Y]) {
	/*Current pixel is on*/
	Active = true;
	SquareUL = (Bitmap[X - 1][Y] || Bitmap[X - 1][Y + 1] || Bitmap[X]
		    [Y + 1]);
	SquareUR = (Bitmap[X + 1][Y] || Bitmap[X + 1][Y + 1] || Bitmap[X]
		    [Y + 1]);
	SquareBL = (Bitmap[X - 1][Y] || Bitmap[X - 1][Y - 1] || Bitmap[X]
		    [Y - 1]);
	SquareBR = (Bitmap[X + 1][Y] || Bitmap[X + 1][Y - 1] || Bitmap[X]
		    [Y - 1]);
	CircleUL = (!Bitmap[X - 1][Y - 1] && !Bitmap[X - 1]
		    [Y] && !Bitmap[X - 1][Y + 1] && !Bitmap[X]
		    [Y + 1] && !Bitmap[X + 1][Y + 1]);
	CircleUR = (!Bitmap[X + 1][Y - 1] && !Bitmap[X + 1]
		    [Y] && !Bitmap[X + 1][Y + 1] && !Bitmap[X]
		    [Y + 1] && !Bitmap[X - 1][Y + 1]);
	CircleBL = (!Bitmap[X - 1][Y + 1] && !Bitmap[X - 1]
		    [Y] && !Bitmap[X - 1][Y - 1] && !Bitmap[X]
		    [Y - 1] && !Bitmap[X + 1][Y - 1]);
	CircleBR = (!Bitmap[X + 1][Y + 1] && !Bitmap[X + 1]
		    [Y] && !Bitmap[X + 1][Y - 1] && !Bitmap[X]
		    [Y - 1] && !Bitmap[X - 1][Y - 1]);
	LTryUUL = (Bitmap[X - 1][Y - 1] && !Bitmap[X - 1][Y] &&
		   !Bitmap[X - 1][Y + 1] && !Bitmap[X][Y + 1] &&
		   !Bitmap[X + 1][Y + 1] && Bitmap[X + 1][Y]);
	LTryUUR = (Bitmap[X + 1][Y - 1] && !Bitmap[X + 1][Y] &&
		   !Bitmap[X + 1][Y + 1] && !Bitmap[X][Y + 1] &&
		   !Bitmap[X - 1][Y + 1] && Bitmap[X - 1][Y]);
	LTryBBL = (Bitmap[X - 1][Y + 1] && !Bitmap[X - 1][Y] &&
		   !Bitmap[X - 1][Y - 1] && !Bitmap[X][Y - 1] &&
		   !Bitmap[X + 1][Y - 1] && Bitmap[X + 1][Y]);
	LTryBBR = (Bitmap[X + 1][Y + 1] && !Bitmap[X + 1][Y] &&
		   !Bitmap[X + 1][Y - 1] && !Bitmap[X][Y - 1] &&
		   !Bitmap[X - 1][Y - 1] && Bitmap[X - 1][Y]);
	LTryULL = (!Bitmap[X - 1][Y - 1] && !Bitmap[X - 1][Y] &&
		   !Bitmap[X - 1][Y + 1] && !Bitmap[X][Y + 1] &&
		   Bitmap[X + 1][Y + 1] && Bitmap[X][Y - 1]);
	LTryURR = (!Bitmap[X + 1][Y - 1] && !Bitmap[X + 1][Y] &&
		   !Bitmap[X + 1][Y + 1] && !Bitmap[X][Y + 1] &&
		   Bitmap[X - 1][Y + 1] && Bitmap[X][Y - 1]);
	LTryBLL = (!Bitmap[X - 1][Y + 1] && !Bitmap[X - 1][Y] &&
		   !Bitmap[X - 1][Y - 1] && !Bitmap[X][Y - 1] &&
		   Bitmap[X + 1][Y - 1] && Bitmap[X][Y + 1]);
	LTryBRR = (!Bitmap[X + 1][Y + 1] && !Bitmap[X + 1][Y] &&
		   !Bitmap[X + 1][Y - 1] && !Bitmap[X][Y - 1] &&
		   Bitmap[X - 1][Y - 1] && Bitmap[X][Y + 1]);
	if (LTryUUL)
	  fprintf(*OutFile,"tuul(%d,%d);", X + ExtSp, Y - Depth);
	if (LTryULL)
	  fprintf(*OutFile,"tull(%d,%d);", X + ExtSp, Y - Depth);
	if (LTryUUR)
	  fprintf(*OutFile,"tuur(%d,%d);", X + ExtSp, Y - Depth);
	if (LTryURR)
	  fprintf(*OutFile,"turr(%d,%d);", X + ExtSp, Y - Depth);
	if (LTryBBL)
	  fprintf(*OutFile,"tbbl(%d,%d);", X + ExtSp, Y - Depth);
	if (LTryBLL)
	  fprintf(*OutFile,"tbll(%d,%d);", X + ExtSp, Y - Depth);
	if (LTryBBR)
	  fprintf(*OutFile,"tbbr(%d,%d);", X + ExtSp, Y - Depth);
	if (LTryBRR)
	  fprintf(*OutFile,"tbrr(%d,%d);", X + ExtSp, Y - Depth);
	if (SquareUL && SquareUR && SquareBL && SquareBR)
	  fprintf(*OutFile, "s(%d,%d);", X + ExtSp, Y - Depth);
	else {
	  if (CircleUL && CircleUR && CircleBL && CircleBR)
	    fprintf(*OutFile, "c(%d,%d);", X + ExtSp, Y - Depth);
	  else {
	    if (!LTryUUL && !LTryULL && !LTryUUR && !LTryBLL)
	      if (SquareUL)
		fprintf(*OutFile, "sul(%d,%d);", X + ExtSp, Y - Depth);
	      else
		fprintf(*OutFile, "tul(%d,%d);", X + ExtSp, Y - Depth);
	    if (!LTryUUL && !LTryURR && !LTryUUR && !LTryBRR)
	      if (SquareUR)
		fprintf(*OutFile, "sur(%d,%d);", X + ExtSp, Y - Depth);
	      else
		fprintf(*OutFile, "tur(%d,%d);", X + ExtSp, Y - Depth);
	    if (!LTryBBL && !LTryULL && !LTryBBR && !LTryBLL)
	      if (SquareBL)
		fprintf(*OutFile, "sbl(%d,%d);", X + ExtSp, Y - Depth);
	      else
		fprintf(*OutFile, "tbl(%d,%d);", X + ExtSp, Y - Depth);
	    if (!LTryBBL && !LTryURR && !LTryBBR && !LTryBRR)
	      if (SquareBR)
		fprintf(*OutFile, "sbr(%d,%d);", X + ExtSp, Y - Depth);
	      else
		fprintf(*OutFile, "tbr(%d,%d);", X + ExtSp, Y - Depth);
	  }
	}
      } else {
	/*Current pixel is off*/
	if (Bitmap[X - 1][Y] && Bitmap[X][Y + 1])
	  if (Bitmap[X - 1][Y - 1] && !Bitmap[X + 1][Y + 1]) {
	    Active=true;
	    fprintf(*OutFile,"ruul(%d,%d);", X + ExtSp, Y - Depth);
	  }
	  else
	    if (Bitmap[X + 1][Y + 1] && !Bitmap[X - 1][Y - 1]) {
		Active=true;
		fprintf(*OutFile,"rull(%d,%d);", X + ExtSp, Y - Depth);
	    }
	    else
	      if (!(Bitmap[X - 1][Y + 1] && Bitmap[X - 1][Y - 1] &&
		  Bitmap[X + 1][Y + 1])) {
		Active = true;
		fprintf(*OutFile, "rul(%d,%d);", X + ExtSp, Y - Depth);
	      }
	if (Bitmap[X + 1][Y] && Bitmap[X][Y + 1])
	  if (Bitmap[X + 1][Y - 1] && !Bitmap[X - 1][Y + 1]) {
	    Active=true;
	    fprintf(*OutFile,"ruur(%d,%d);", X + ExtSp, Y - Depth);
	  }
	  else
	    if (Bitmap[X - 1][Y + 1] && !Bitmap[X + 1][Y - 1]) {
		Active=true;
		fprintf(*OutFile,"rurr(%d,%d);", X + ExtSp, Y - Depth);
	    }
	    else
	      if (!(Bitmap[X + 1][Y + 1] && Bitmap[X - 1][Y + 1] &&
		  Bitmap[X + 1][Y - 1])) {
		Active = true;
		fprintf(*OutFile, "rur(%d,%d);", X + ExtSp, Y - Depth);
	      }
	if (Bitmap[X - 1][Y] && Bitmap[X][Y - 1])
	  if (Bitmap[X - 1][Y + 1] && !Bitmap[X + 1][Y - 1]) {
	    Active=true;
	    fprintf(*OutFile,"rbbl(%d,%d);", X + ExtSp, Y - Depth);
	  }
	  else
	    if (Bitmap[X + 1][Y - 1] && !Bitmap[X - 1][Y + 1]) {
		Active=true;
		fprintf(*OutFile,"rbll(%d,%d);", X + ExtSp, Y - Depth);
	    }
	    else
	      if (!(Bitmap[X - 1][Y - 1] && Bitmap[X - 1][Y + 1] &&
		  Bitmap[X + 1][Y - 1])) {
		Active = true;
		fprintf(*OutFile, "rbl(%d,%d);", X + ExtSp, Y - Depth);
	      }
	if (Bitmap[X + 1][Y] && Bitmap[X][Y - 1])
	  if (Bitmap[X + 1][Y + 1] && !Bitmap[X - 1][Y - 1]) {
	    Active=true;
	    fprintf(*OutFile,"rbbr(%d,%d);", X + ExtSp, Y - Depth);
	  }
	  else
	    if (Bitmap[X - 1][Y - 1] && !Bitmap[X + 1][Y + 1]) {
		Active=true;
		fprintf(*OutFile,"rbrr(%d,%d);", X + ExtSp, Y - Depth);
	    }
	    else
	      if (!(Bitmap[X + 1][Y - 1] && Bitmap[X - 1][Y - 1] &&
		  Bitmap[X + 1][Y + 1])) {
		Active = true;
		fprintf(*OutFile, "rbr(%d,%d);", X + ExtSp, Y - Depth);
	      }
      }
      if (Active)
	putc('\n', *OutFile);
    }
  }
  fprintf(*OutFile, "endchar;\n\n");
}
 
 
Static Void EndOut(OutFile, FileName)
FILE **OutFile;
Char *FileName;
{
  fprintf(*OutFile, "font_identifier \"%s\";\n", FileName);
  fprintf(*OutFile, "font_coding_scheme \"JTeX\";\n");
  fprintf(*OutFile, "font_slant slant;\n");
  fprintf(*OutFile, "font_normal_space 0pt#;\n");
  fprintf(*OutFile, "font_normal_stretch 0pt#;\n");
  fprintf(*OutFile, "font_normal_shrink 0pt#;\n");
  fprintf(*OutFile, "font_x_height 38/300in#; %%ex\n");
  fprintf(*OutFile, "font_quad 38/300in#; %%em\n");
  fprintf(*OutFile, "font_extra_space 0pt#;\n\n");
  fprintf(*OutFile, "bye\n");
}
 
 
main(argc, argv)
int argc;
Char *argv[];
{
  Char STR1[256], STR2[256], STR3[256], STR4[256], STR5[256];
  Char STR6[256];
  short FORLIM;
  short FORLIM1;
 
  /* PASCAL_MAIN(argc, argv); */
  OutFile = NULL;
  InFile = NULL;
  printf("\nBitmaps to METAFONT Conversion Program (UNIX C Version 3.10.\n");
  /*To make Borland happy*/
  printf("Copyright F.Jalbert and M.Watanabe 1990, 1991.\n\n");
 
  if (argc >= 3)
    SizeMax = atof(argv[2]);
  else
    SizeMax = 24;
  SizeMax1 = SizeMax + 1;
  if (argc >= 4)
    SizeExt = atof(argv[3]);
  else
    SizeExt = 2;
 
  if (argc >= 5) {
    if (!strcmp(strcpy(STR1, argv[4]), "M") ||
	!strcmp(strcpy(STR2, argv[4]), "m"))
      Bold = 0.5;
    else {
      if (!strcmp(strcpy(STR3, argv[4]), "B") ||
	  !strcmp(strcpy(STR4, argv[4]), "b"))
	Bold = 0.8;
      else {
	Bold = atof(argv[4]);
	Bold = (1.0 + Bold) / 2.0;
      }
    }
  } else
    Bold = 0.5;
  if (Bold > 1.0) Bold = 1.0;
 
  printf("Opening Bitmap file");
  if (argc >= 2) {
    strcpy(STR3, argv[1]);
    strcpy(InFile_NAME, STR3);
  } else
    strcpy(InFile_NAME, "JIS24");
  if (InFile != NULL)
    InFile = freopen(InFile_NAME, "r+b", InFile);
  else
    InFile = fopen(InFile_NAME, "r+b");
  if (InFile == NULL)
    fprintf(stderr,"FileNotFound.\n");
  printf(".\n\n");
 
  printf("METAFONT file name? ");
  gets(FileName);
  printf("\nCreating METAFONT file %s.mf", FileName);
  sprintf(STR6, "%s.mf", FileName);
  strcpy(OutFile_NAME, STR6);
  if (OutFile != NULL)
    OutFile = freopen(OutFile_NAME, "w", OutFile);
  else
    OutFile = fopen(OutFile_NAME, "w");
  if (OutFile == NULL)
    fprintf(stderr,"FileNotFound.\n");
  printf(".\n\n");
 
  printf("Writing initial METAFONT header");
  BeginOut(&OutFile, FileName);
  printf(".\n\n");
 
  /*Number of the Bitmap ready to be read*/
  CurrentBitmap = 1;
  /*First METAFONT character number*/
  Number = 0;
  do {
    printf("Bitmap number? ");
    scanf("%hd%*[^\n]", &WantedBitmap);
    getchar();
    printf("\nBitmap number %d.\n", WantedBitmap);
    if ((unsigned)WantedBitmap > BitmapMax) {
      printf("Bitmap number out of range! Premature termination...\n");
      WantedBitmap = 0;
    }
 
    if (WantedBitmap != 0) {
      /*Sequential file access forces a reset if we must read backwards*/
      if (WantedBitmap < CurrentBitmap) {
	printf("Resetting Bitmaps file");
	if (InFile != NULL)
	  InFile = freopen(InFile_NAME, "r+b", InFile);
	else
	  InFile = fopen(InFile_NAME, "r+b");
	if (InFile == NULL)
          fprintf(stderr,"FileNotFound.\n");
	CurrentBitmap = 1;
	printf(".\n");
      }
 
      /*Simply read and discard unwanted Bitmaps*/
      if (WantedBitmap > CurrentBitmap) {
	printf("Skipping Bitmap(s)");
	FORLIM = WantedBitmap;
	for (BitmapPtr = CurrentBitmap; BitmapPtr < FORLIM; BitmapPtr++) {
	  FORLIM1 = (short)SizeMax * ((SizeMax + 7) / 8);
	  for (X = 1; X <= FORLIM1; X++)
	    fread(&Data, sizeof(uchar), 1, InFile);
	  if (BitmapPtr % 500 == 0)
	    printf(" %d", BitmapPtr);
	}
	printf(".\n");
      }
 
      printf("Reading Bitmap");
      CurrentBitmap = WantedBitmap;
      ScanBitmap(&InFile, Bitmap);
      CurrentBitmap++;
      printf(".\n");
 
      ScanSides(Bitmap, &XMin, &XMax, &YMin, &YMax);
      if (XMin > XMax)
	printf("Bitmap is empty, no METAFONT code to generate!\n");
      else {
	printf("Writing METAFONT code");
	MiddleOut(&OutFile, Bitmap, XMin, XMax, YMin, YMax, Number);
	printf(".\n");
      }
      putchar('\n');
      /*Ready to generate next METAFONT character*/
      Number++;
    }
  } while (WantedBitmap != 0);
 
  printf("\nClosing Bitmap file");
 
  if (InFile != NULL)
    fclose(InFile);
  InFile = NULL;
  printf(".\n");
 
  printf("Writing final METAFONT header");
  EndOut(&OutFile, FileName);
  printf(".\n");
 
  printf("Closing METAFONT file %s.mf", FileName);
  if (OutFile != NULL)
    fclose(OutFile);
  OutFile = NULL;
  printf(".\n\n");
 
  printf("METAFONT code for %d Bitmap(s) generated.\n\n", Number);
  if (InFile != NULL)
    fclose(InFile);
  if (OutFile != NULL)
    fclose(OutFile);
  exit(0);
}
 
/* End. */
